import { OnDestroy, AfterViewInit, ElementRef, EventEmitter } from '@angular/core';
import { MaterialsWidthHelper } from 'ivy.angular.material.helpers';
import { StringHelper } from 'ivy.angular.value-helpers';
import { TinyMceInitializationService } from '../Services/tiny-mce-initialization.service';
import { TinyMceConfigurationService } from '../Services/tiny-mce-configuration.service';
import * as tinymce from 'tinymce';
import 'tinymce/tinymce';
import 'tinymce/themes/modern/theme';
import 'tinymce/themes/inlite/theme';
/**
 * Is there any way we can use a provider pattern here in order to populate the cssLocation and plugins variables?
 *
 */
export declare class IvyAngularTinyEditorInlineDirective implements OnDestroy, AfterViewInit {
    private elemRef;
    private stringHelper;
    private matWidthHelper;
    private tinymceSvc;
    private tinyMceConfigSvc;
    richTextDisabled: boolean;
    cssLocation: string;
    plugins: string;
    onTextChange: EventEmitter<{}>;
    private elementId;
    editor: tinymce.Editor;
    constructor(elemRef: ElementRef, stringHelper: StringHelper, matWidthHelper: MaterialsWidthHelper, tinymceSvc: TinyMceInitializationService, tinyMceConfigSvc: TinyMceConfigurationService);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    configureEditor(editor: tinymce.Editor): void;
    onKeyUp(): void;
}
