"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
// ./app/shared/hidden.directive.ts
var core_1 = require("@angular/core");
// TinyMCE JS Imports
/*
 * Note, this library is loaded via the CDN in order to prevent issues we're dealing with from setting up the skin directory
 * Currently, the skin directory is unable to be loaded into the webpack final product correctly.
 * As such, by relying on the CDN, it gets loaded with all of the appropriate assets and we don't have to worry about messing
 * with some crazy custom webpack configuration to get it loaded into our application.
 */
// My Services
var ivy_angular_material_helpers_1 = require("ivy.angular.material.helpers");
var ivy_angular_value_helpers_1 = require("ivy.angular.value-helpers");
var tiny_mce_initialization_service_1 = require("../Services/tiny-mce-initialization.service");
var tiny_mce_configuration_service_1 = require("../Services/tiny-mce-configuration.service");
// Tiny MCE
require("tinymce/tinymce");
// Tiny MCE Themes
require("tinymce/themes/modern/theme");
require("tinymce/themes/inlite/theme");
/**
 * Is there any way we can use a provider pattern here in order to populate the cssLocation and plugins variables?
 *
 */
var IvyAngularTinyEditorInlineDirective = /** @class */ (function () {
    function IvyAngularTinyEditorInlineDirective(elemRef, stringHelper, matWidthHelper, tinymceSvc, tinyMceConfigSvc) {
        this.elemRef = elemRef;
        this.stringHelper = stringHelper;
        this.matWidthHelper = matWidthHelper;
        this.tinymceSvc = tinymceSvc;
        this.tinyMceConfigSvc = tinyMceConfigSvc;
        this.onTextChange = new core_1.EventEmitter();
        this.editor = null;
    }
    IvyAngularTinyEditorInlineDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.elementId = this.elemRef.nativeElement.id;
        if (this.stringHelper.isNullOrEmpty(this.elementId)) {
            throw 'Unable to instantiate the Inline TinyEditor without an Id on the element.';
        }
        if (!this.richTextDisabled) {
            var tinyMceConfig = this.tinyMceConfigSvc.generateConfigs(this.elementId, function (editor) { return _this.configureEditor(editor); });
            this.tinymceSvc.init(tinyMceConfig);
        }
    };
    IvyAngularTinyEditorInlineDirective.prototype.ngOnDestroy = function () {
        if (this.editor != null) {
            this.editor.destroy();
        }
        this.tinymceSvc.remove(this.editor);
    };
    IvyAngularTinyEditorInlineDirective.prototype.configureEditor = function (editor) {
        var _this = this;
        this.editor = editor;
        editor.on('keyup change', function () { return _this.onKeyUp; });
    };
    IvyAngularTinyEditorInlineDirective.prototype.onKeyUp = function () {
        var content = this.editor.getContent();
        this.onTextChange.emit(content);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], IvyAngularTinyEditorInlineDirective.prototype, "richTextDisabled", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], IvyAngularTinyEditorInlineDirective.prototype, "cssLocation", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], IvyAngularTinyEditorInlineDirective.prototype, "plugins", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], IvyAngularTinyEditorInlineDirective.prototype, "onTextChange", void 0);
    IvyAngularTinyEditorInlineDirective = __decorate([
        core_1.Directive({ selector: '[ivy-tiny-editor-inline]' }),
        __metadata("design:paramtypes", [core_1.ElementRef,
            ivy_angular_value_helpers_1.StringHelper,
            ivy_angular_material_helpers_1.MaterialsWidthHelper,
            tiny_mce_initialization_service_1.TinyMceInitializationService,
            tiny_mce_configuration_service_1.TinyMceConfigurationService])
    ], IvyAngularTinyEditorInlineDirective);
    return IvyAngularTinyEditorInlineDirective;
}());
exports.IvyAngularTinyEditorInlineDirective = IvyAngularTinyEditorInlineDirective;
//# sourceMappingURL=tiny-editor-inline.directive.js.map